// 定义持续时间格式化函数
function formatDuration(ticks) {
    let seconds = Math.floor(ticks / 20);
    let minutes = Math.floor(seconds / 60);
    let remainingSeconds = seconds % 60;
    return `${minutes}:${remainingSeconds.toString().padStart(2, '0')}`;
}

// 定义罗马数字转换函数
function toRoman(num) {
    let roman = ['I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X', 'XI', 'XII', 'XIII'];
    return num < roman.length ? roman[num] : (num + 1).toString();
}

ItemEvents.tooltip((event) => {
    event.addAdvanced([
        "farm_and_charm:baked_lamb_ham",
        "farm_and_charm:barley_soup",
        "farm_and_charm:corn_grits",
        "farm_and_charm:farmer_salad",
        "farm_and_charm:farmers_bread",
        "farm_and_charm:lettuce",
        "farm_and_charm:nettle_tea",
        "farm_and_charm:oat_pancake",
        "farm_and_charm:oatmeal_with_strawberries",
        "farm_and_charm:pasta_with_onion_sauce",
        "farm_and_charm:potato_soup",
        "farm_and_charm:potato_with_roast_meat",
        "farm_and_charm:ribwort_tea",
        "farm_and_charm:roasted_chicken",
        "farm_and_charm:roasted_corn",
        "farm_and_charm:simple_tomato_soup",
        "farm_and_charm:strawberry_tea",
        "farm_and_charm:strawberry",
        "farm_and_charm:stuffed_chicken",
        "farmersdelight:bacon_and_eggs",
        "farmersdelight:barbecue_stick",
        "farmersdelight:beef_stew",
        "farmersdelight:cabbage_rolls",
        "farmersdelight:cabbage",
        "farmersdelight:cod_roll",
        "farmersdelight:cooked_rice",
        "farmersdelight:egg_sandwich",
        "farmersdelight:fish_stew",
        "farmersdelight:fried_egg",
        "farmersdelight:fruit_salad",
        "farmersdelight:glow_berry_custard",
        "farmersdelight:kelp_roll_slice",
        "farmersdelight:melon_popsicle",
        "farmersdelight:mixed_salad",
        "farmersdelight:nether_salad",
        "farmersdelight:pumpkin_slice",
        "farmersdelight:ratatouille",
        "farmersdelight:salmon_roll",
        "farmersdelight:stuffed_potato",
        "farmersdelight:tomato",
        "farmersdelight:vegetable_soup",
        "minecraft:apple",
        "minecraft:beetroot_soup",
        "minecraft:beetroot",
        "minecraft:carrot",
        "minecraft:cookie",
        "minecraft:enchanted_golden_apple",
        "minecraft:glow_berries",
        "minecraft:golden_apple",
        "minecraft:golden_carrot",
        "minecraft:honey_bottle",
        "minecraft:melon_slice",
        "minecraft:sweet_berries",
        "mynethersdelight:bleeding_tartar",
        "mynethersdelight:blue_tenderloin_steak",
        "mynethersdelight:boiled_egg",
        "mynethersdelight:bullet_pepper",
        "mynethersdelight:cooked_loin",
        "mynethersdelight:deviled_egg",
        "mynethersdelight:hot_wings",
        "mynethersdelight:hotdog",
        "mynethersdelight:plate_of_cold_striderloaf",
        "mynethersdelight:plate_of_striderloaf",
        "mynethersdelight:strider_egg",
        "quark:cooked_crab_leg",
        "rusticdelight:bell_pepper_green",
        "rusticdelight:bell_pepper_pasta",
        "rusticdelight:bell_pepper_red",
        "rusticdelight:bell_pepper_roll_green",
        "rusticdelight:bell_pepper_roll_red",
        "rusticdelight:bell_pepper_roll_yellow",
        "rusticdelight:bell_pepper_soup",
        "rusticdelight:bell_pepper_yellow",
        "rusticdelight:calamari_roll",
        "rusticdelight:cherry_blossom_pancake",
        "rusticdelight:cherry_blossom_roll",
        "rusticdelight:chocolate_pancake",
        "rusticdelight:fried_dough",
        "rusticdelight:fried_dumplings",
        "rusticdelight:fried_mushrooms",
        "rusticdelight:fruit_beignet",
        "rusticdelight:honey_coffee",
        "rusticdelight:honey_pancake",
        "rusticdelight:pancake",
        "rusticdelight:potato_salad",
        "rusticdelight:pumpkin_pancake",
        "rusticdelight:stuffed_bell_pepper_green",
        "rusticdelight:stuffed_bell_pepper_red",
        "rusticdelight:stuffed_bell_pepper_yellow",
        "rusticdelight:vegetable_pancake",
        "spawn:cooked_tuna_chunk",
        "spawn:escargot",
        "untitledduckmod:cooked_duck",
        "untitledduckmod:cooked_goose",
    ], (item, advanced, text) => {
        let originalName = text.length > 0 ? Text.of(text.get(0)).copy() : Text.of(item.id).gold()
        text.clear()
        text.add(0, originalName)
        item.item.foodProperties.effects.forEach(effect => {
            let Instance = effect.first
            let effectKey = Instance.effect.descriptionId
            let effectName = Text.translate(effectKey).getString()
            let amplifier = Instance.amplifier
            let romanLevel = toRoman(amplifier)
            let duration = Instance.duration
            let formattedDuration = formatDuration(duration)
            text.add(1, Text.green(`${effectName} ${romanLevel} (${formattedDuration})`))
        })
    })
    event.addAdvanced([
        "farm_and_charm:bacon_with_eggs",
        "farm_and_charm:barley_patties_with_potatoes",
        "farm_and_charm:beef_patty_with_vegetables",
        "farm_and_charm:cooked_cod",
        "farm_and_charm:cooked_salmon",
        "farm_and_charm:goulash",
        "farm_and_charm:grandmothers_strawberry_cake",
        "farm_and_charm:lamb_with_corn",
        "farm_and_charm:sausage_with_oat_patty",
        "farm_and_charm:stuffed_rabbit",
        "farmersdelight:bacon_sandwich",
        "farmersdelight:chicken_sandwich",
        "farmersdelight:dumplings",
        "farmersdelight:hamburger",
        "farmersdelight:kelp_roll",
        "farmersdelight:mushroom_rice",
        "farmersdelight:mutton_wrap",
        "farmersdelight:pasta_with_meatballs",
        "farmersdelight:pasta_with_mutton_chop",
        "farmersdelight:smoked_ham",
        "farmersdelight:steak_and_potatoes",
        "minecraft:baked_potato",
        "minecraft:bread",
        "minecraft:cooked_beef",
        "minecraft:cooked_chicken",
        "minecraft:cooked_cod",
        "minecraft:cooked_mutton",
        "minecraft:cooked_porkchop",
        "minecraft:cooked_rabbit",
        "minecraft:cooked_salmon",
        "minecraft:cookie",
        "minecraft:honey_bottle",
        "minecraft:mushroom_stew",
        "minecraft:rabbit_stew",
        "mynethersdelight:breakfast_sampler",
        "mynethersdelight:burnt_roll",
        "mynethersdelight:chilidog",
        "mynethersdelight:crimson_stroganoff",
        "mynethersdelight:ghast_salad",
        "mynethersdelight:hot_wings_bucket",
        "mynethersdelight:plate_of_ghasta_with_cream",
        "mynethersdelight:plate_of_stuffed_hoglin_ham",
        "mynethersdelight:plate_of_stuffed_hoglin",
        "mynethersdelight:rock_soup",
        "mynethersdelight:sausage_and_potatoes",
        "mynethersdelight:spicy_cotton",
        "mynethersdelight:spicy_curry",
        "mynethersdelight:spicy_hoglin_stew",
        "mynethersdelight:spicy_skewer",
        "mynethersdelight:strider_stew",
        "mynethersdelight:strider_with_grilled_fungus",
        "rusticdelight:fried_calamari",
        "rusticdelight:fried_chicken",
        "rusticdelight:spring_rolls",
        "rusticdelight:sweet_salad",
        "rusticdelight:syrup_sandwich",
        "spawn:escargot",
        "spawn:tuna_sandwich",
    ], (item, advanced, text) => {
        let originalName = text.length > 0 ? Text.of(text.get(0)).copy() : Text.of(item.id).gold()
        text.clear()
        text.add(0, Text.yellow(originalName))
        item.item.foodProperties.effects.forEach(effect => {
            let Instance = effect.first
            let effectKey = Instance.effect.descriptionId
            let effectName = Text.translate(effectKey).getString()
            let amplifier = Instance.amplifier
            let romanLevel = toRoman(amplifier)
            let duration = Instance.duration
            let formattedDuration = formatDuration(duration)
            text.add(1, Text.green(`${effectName} ${romanLevel} (${formattedDuration})`))
        })
    })
    event.addAdvanced([
        "farmersdelight:vegetable_noodles",
        "farmersdelight:grilled_salmon",
        "farmersdelight:squid_ink_pasta",
        "farmersdelight:roast_chicken",
        "farmersdelight:stuffed_pumpkin",
        "farmersdelight:honey_glazed_ham",
        "farmersdelight:shepherds_pie",
        "farm_and_charm:farmers_breakfast",
        "farm_and_charm:chicken_wrapped_in_bacon",
        "farmersdelight:roasted_mutton_chops",
        "farmersdelight:noodle_soup",
        "farmersdelight:baked_cod_stew",
        "farmersdelight:pumpkin_soup",
        "farmersdelight:fried_rice",
        "farmersdelight:chicken_soup",
        "rusticdelight:coffee_braised_beef",
        "mynethersdelight:spicy_noodle_soup",
        "mynethersdelight:plate_of_stuffed_hoglin_snout",
        "mynethersdelight:fried_hoglin_chop"
    ], (item, advanced, text) => {
        let originalName = text.length > 0 ? Text.of(text.get(0)).copy() : Text.of(item.id).gold()
        text.clear()
        text.add(0, Text.gold(originalName))
        item.item.foodProperties.effects.forEach(effect => {
            let Instance = effect.first
            let effectKey = Instance.effect.descriptionId
            let effectName = Text.translate(effectKey).getString()
            let amplifier = Instance.amplifier
            let romanLevel = toRoman(amplifier)
            let duration = Instance.duration
            let formattedDuration = formatDuration(duration)
            text.add(1, Text.green(`${effectName} ${romanLevel} (${formattedDuration})`))
        })
    })
})
