//tp时传送跟随的士兵
ForgeEvents.onEvent("net.minecraftforge.event.entity.EntityTeleportEvent", event => {
    global.EntityTeleportEvent(event)
})
/**
 * 
 * @param {Internal.EntityTeleportEvent} event 
 */
global.EntityTeleportEvent = event => {
    if (event.entity.type == 'minecraft:player') {
        let player = event.entity;
        // 有标记时跳过后续处理并删除标记
        if (player.tags.contains('temp_tp')) {
            player.removeTag('temp_tp');
            return;
        }
        // 存储传送数据到持久化数据
        let data = player.persistentData;
        data.putDouble("snk_tp_x", event.targetX);
        data.putDouble("snk_tp_y", event.targetY);
        data.putDouble("snk_tp_z", event.targetZ);
        data.putFloat("snk_tp_yaw", player.yaw);
        data.putFloat("snk_tp_pitch", player.pitch);
        // 没有维度数据时储存玩家当前维度
        if (!data.getString("snk_tp_dim")) {
            data.putString("snk_tp_dim", player.level.dimension.path)
        }
        // 添加循环标记
        player.addTag('temp_tp');
        let uuid = player.uuid;
        // 传送士兵逻辑（遗留的数据包辨识体系改起来麻烦先RCMD用着吧）
        player.server.runCommandSilent(`execute as ${uuid} run scoreboard players operation TP snk_newid = @s snk_newid`);
        player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
        player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
        // 延迟传送玩家（延迟后循环进入第二次传送事件）
        player.server.scheduleInTicks(5, () => {
            player.teleportTo(
                data.getString("snk_tp_dim"),
                data.getDouble("snk_tp_x"),
                data.getDouble("snk_tp_y"),
                data.getDouble("snk_tp_z"),
                data.getFloat("snk_tp_yaw"),
                data.getFloat("snk_tp_pitch")
            );
        });
        // 删除第一次循环的传送事件
        event.setCanceled(true);
    }
};
//使用指路石时传送跟随的士兵
ForgeEvents.onEvent("net.blay09.mods.waystones.api.WaystoneTeleportEvent$Pre", event => {
    global.WaystoneTeleportEvent(event)
});

/**
 * 
 * @param {Internal.WaystoneTeleportEvent$Pre} event 
 */
global.WaystoneTeleportEvent = event => {
    let player = event.context.entity
    // 存储传送数据到持久化数据
    let data = player.persistentData
    data.putDouble("snk_tp_x", event.destination.location.get('x'));
    data.putDouble("snk_tp_y", event.destination.location.get('y'));
    data.putDouble("snk_tp_z", event.destination.location.get('z'));
    data.putFloat("snk_tp_yaw", player.yaw);
    data.putFloat("snk_tp_pitch", player.pitch);
    data.putString("snk_tp_dim", event.destination.level.dimension.path);
    // 添加循环标记
    player.addTag('temp_tp');
    let uuid = player.uuid
    // 传送士兵逻辑
    player.server.runCommandSilent(`execute as ${uuid} run scoreboard players operation TP snk_newid = @s snk_newid`);
    player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
    player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
    // 延迟传送玩家（以TP方式直接进入第二次传送事件）
    player.server.scheduleInTicks(5, () => {
        player.teleportTo(
            data.getString("snk_tp_dim"),
            data.getDouble("snk_tp_x"),
            data.getDouble("snk_tp_y"),
            data.getDouble("snk_tp_z"),
            data.getFloat("snk_tp_yaw"),
            data.getFloat("snk_tp_pitch")
        );
    });
    // 手持传送石获得返程石
    let mainHandItem = player.getMainHandItem();
    if (mainHandItem.id === 'waystones:warp_stone') {
        let fragile_dim = player.level.dimension.path
        let fragile_x = player.x
        let fragile_y = player.y
        let fragile_z = player.z
        let specialItem = Item.of('l2complements:fragile_warp_stone', {
            display: {
                Name: '{"text":"返程石", "color":"gold", "italic":false}',
                Lore: [
                    '{"text":"返回使用传送石传送的位置"}'
                ]
            },
            pos: {
                dim:fragile_dim,
                x:fragile_x,
                y:fragile_y,
                z:fragile_z
            }
        })
        player.give(specialItem)
        player.tell(Text.gold("传送石的残余能量记录了位置"))
    }
    // 删除石碑传送玩家事件
    event.setCanceled(true);
}
//跨越维度时传送跟随的士兵
ForgeEvents.onEvent("net.minecraftforge.event.entity.EntityTravelToDimensionEvent", event => {
    global.EntityTravelToDimensionEvent(event)
})
/**
 * 
 * @param {Internal.EntityTravelToDimensionEvent} event 
 */
global.EntityTravelToDimensionEvent = event => {
    if (event.entity.type == 'minecraft:player') {
        let player = event.entity
        // 记录跨越维度事件，在TP事件中使用
        let data = player.persistentData;
        data.putString("snk_tp_dim", event.dimension.path);
        let uuid = player.uuid
        // 传送士兵逻辑
        event.entity.server.runCommandSilent(`execute as ${uuid} run scoreboard players operation TP snk_newid = @s snk_newid`)
        event.entity.server.runCommandSilent(`execute as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp @s ${uuid}`)
        event.entity.server.runCommandSilent(`execute as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp @s ${uuid}`)
    }
}